
v2.7.14

**【**常见问题收集了我们所有客户在使用中遇到的问题，有些问题虽然不影响使用但是可能有您希望优化的关键细节，建议接入前阅读[《常见问题对接文档》](https://shimo.im/docs/SkjBwF0OwHYmUu5q/)**】**

flowType

## 一、注册智齿账号
请先确保已注册智齿客服账号（[www.sobot.com](http://www.sobot.com)）。

### 1 获取appKey
![图片](https://images-cdn.shimo.im/Nt8Qbj7p9s4sN5Wq/image.png!thumbnail)

<管理后台-设置-支持渠道-APP>

## 二、下载智齿SDK
点击下载最新最新SDK包。

**普通版**

# 快速集成
## 一、将SDK添加到项目（必须）
### 1 CocoaPods集成
在 Podfile 文件中加入：

```
pod 'SobotKit'
```
如果搜索不到最新版本，请运行以下命令更新CocoPods仓库
```
pod repo update --verbose
```
### 2 手动集成
解压[iOS_SDK]，添加必要文件SobotKit.framework和SobotKit.bundle到你的工程里。智齿iOS_SDK 的实现，依赖了一些系统的框架，在开发应用时需要在工程里加入这些框架。开发者首先点击工程右边的工程名，然后在工程名右边依次选择TARGETS -> BuiLd Phases -> Link Binary With Libraries，展开 LinkBinary With Libraries后点击展开后下面的 + 来添加下面的依赖项:

* AVFoundation.framework
* AssetsLibrary.framework
* AudioToolbox.framework
* SystemConfiguration.framework
* MobileCoreServices.framework
* libz.1.2.5.tbd( dylib)
* webkit.framwork
### 3 文件介绍
SDK包含（SobotKit.framework和SobotKit.bundle）、SobotDemo、和相关说明文档。

&amp;nbsp;

| 文件名   | 说明   |    |
|:----|:----|:----|
| SobotKit.framework   | 智齿SDK核心代码库   |    |
| SobotKit.bundle   | 图片资源文件 表情资源文件 语言文件   |    |
| ZCLibInitInfo.h   | 实体类：基础参数类(自定义用户配置信息)   |    |
| ZCKitInfo.h   | 实体类：基础参数(UI自定义)   |    |
| ZCSobot.h   | 连接客户端到智齿客服，该文件提供接入功能   |    |
| SobotKit.h   | 该文件引用所有SDK需要的文件   |    |
| ZCUIBaseController   | UI界面父类，定义顶部View   |    |
| ZCChatController   | 主要UI界面，如果需要自己实现跳转，可直接引用实现   |    |
| SobotLocalizable.strings   | 国际化语言文件   |    |
| ZCLibClient.h   | 全局配置类   |    |
|    |    |    |



### 二、初始化SDK（必须）
初始化参数和调用方式：初始化信息和UI自定义分为2个模型，使用ZCLibInitInfo存储初始化属性，ZCKitInfo设置相关UI属性，一起传递给初始化方法，详情见Demo调用代码；

主要调用代码如下（详细见Demo）：

【注意：启动智齿SDK之前，必须调用初始化接口initSobotSDK，否则将无法启动SDK】

### **1 启动**
```
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {   
    // 错误日志收集
    [ZCLibClient setZCLibUncaughtExceptionHandler];
    /**
      *  接口域名,
      * 默认SaaS平台域名为:https://api.sobot.com
      * 如果您是腾讯云服务，请设置为：https://ten.sobot.com
      * 如果您是本地化部署，请使用你们自己的部署的服务域名
      */
     //[ZCLibClient getZCLibClient].libInitInfo.apiHost = @"域名";
    
    // 初始化，必须执行，并且必须在进入SDK之前调用
    [[ZCLibClient getZCLibClient] initSobotSDK:@"your appkey"];
    return YES;
}
// 启动
if([ZCLibClient getZCLibClient].libInitInfo == nil){
    [ZCLibClient getZCLibClient].libInitInfo = [ZCLibInitInfo new];
}
ZCLibInitInfo *initInfo = [ZCLibClient getZCLibClient].libInitInfo;
// 企业编号 必填
initInfo.appKey = @"Your appKey";
// 用户id，用于标识用户，建议填写 (注意：userId不要写死比如0，123456，不要设置默认值，否则获取的历史记录相同)
initInfo.userId = @"Your userId";
//配置UI
ZCKitInfo *uiInfo=[ZCKitInfo new];
// 是否显示转人工按钮
uiInfo.isShowTansfer = YES;
//设置启动参数
[[ZCLibClient getZCLibClient] setLibInitInfo:initInfo];
// 智齿SDK初始化启动事例，
// 必须在之前调用 [[ZCLibClient getZCLibClient]initSobotSDK:@"your appkey" result:^  (id object) {
   }];
[注意:初始化方法从2.7.0开始messageLinkClick带有Bool返回值，true自己处理，false表示不处理]
// target  如果传入的参数不为nil 需要实现 -(void)openLeaveMsgClick:(NSString*)tipMsg;代理方法 留言跳转到用户自定义的留言页面
[ZCSobot startZCChatVC:uiInfo with:self target:nil pageBlock:^(id object, ZCPageBlockType type) {
                // 点击返回
                if(type==ZCPageBlockGoBack){
//                    NSLog(@"点击了关闭按钮");
                }
                
                // 页面UI初始化完成，可以获取UIView，自定义UI
                if(type==ZCPageBlockLoadFinish){
//                    NSLog(@"页面加载完成");
                }
    } messageLinkClick:^(NSString *link) {
        NSLog(@"%@",link);
//        当收到link = sobot://sendlocation 调用智齿接口发送位置信息
//        当收到link = sobot://openlocation?latitude=xx&longitude=xxx&address=xxx 可根据自己情况处理相关业务
        if( [link hasPrefix:@"sobot://sendlocation"]){
            //发送坐标点
            NSString *fullPath = GetDocumentsFilePath(fname);
            [imageData writeToFile:fullPath atomically:YES];
            // 发送位置信息
            [ZCSobot sendLocation:@{
                                    @"lat":@"40.001693",
                                    @"lng":@"116.353276",
                                    @"localLabel":@"北京市海淀区学清路38号金码大厦A座23层金码大酒店",
                                    @"localName":@"云景四季餐厅",
                                    @"file":fullPath}];
            return YES;
        }else if([link hasPrefix:@"sobot://openlocation"]){
            // 解析经度、纬度、地址：latitude=xx&longitude=xxx&address=xxx
            // 跳转到地图的位置
            NSLog(link);
            // 测试打开地图 高德网页版            
            NSString * urlString = @"";
            urlString = [[NSString stringWithFormat:@"http://uri.amap.com/marker?position=%f,%f&name=%@&coordinate=gaode&src=%@&callnative=0",@116.353276,@40.001693,@"北京市海淀区学清路38号金码大厦A座23层金码大酒店",@"智齿SDK"] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
            [[UIApplication sharedApplication]openURL:[NSURL URLWithString:urlString]];
          return YES;
        }
        return NO;
    }];
// 启动商家列表（仅电商版本支持）
// 商家初始化UI信息，用于启动对应客服页面使用，不能为空 
ZCKitInfo *uiInfo=[ZCKitInfo new];
[ZCSobot startZCChatListView:uiInfo with:self];
```
### 2 离线消息
```
//  @note 检查当前消息通道是否建立，没有就重新建立 如果调用 closeIMConnection 后，可调用此方法重新建立链接
[[ZCLibClient getZCLibClient] checkIMConnected];       
// ReceivedMessageBlock 未读消息数， obj 当前消息  unRead 未读消息数
 [ZCLibClient getZCLibClient].receivedBlock = ^(id obj,int unRead,NSDictionary *object){
//        NSLog(@"当前消息数：%d \n %@",unRead,obj);
    };
    
// 关闭通道，清理内存，退出智齿客户
 说明：调用此方法后将不能接收到离线消息，除非再次进入智齿SDK重新激活
 isClosePush:YES ,是关闭push；NO离线用户，但是可以收到push推送+(void) closeAndoutZCServer:(BOOL) isClosePush; 
[ZCLibClient  closeAndoutZCServer:YES];
```
### 注：如果你需要SDK推送的功能请参考以下消息通知、注册推送的相关代码，如果您的项目不需要请略过。
### 3 消息通知 
在ZCLibClient.h中

```
/**
推送的token
每次启动应用都需要重新设置
*/
@property (nonatomic,strong) NSData *token;
/**
测试模式，
根据此设置调用的推送证书，默认NO
NO ,调用生产环境
YES，测试环境
*/
@property (nonatomic,assign) BOOL isDebugMode;
/**
自动提醒消息
说明：如果开启自动提醒消息，当没有在智齿聊天页面的时候，都会主动把消息作为本地通知展示
*/
@property (nonatomic,assign) BOOL autoNotification;
/**
获取未读消息数
@return 未读消息数(进入智齿聊天页面会清空)
*/
-(int) getUnReadMessage;
```
* 注册推送

在AppDelegate.m 文件中注册推送。

* 导入头文件
```
#import <SobotKit/SobotKit.h>
#import <UserNotifications/UserNotifications.h>
#define SYSTEM_VERSION_GRATERTHAN_OR_EQUALTO(v)  ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedAscending)
```
* 服从协议
```
<UIApplicationDelegate,UNUserNotificationCenterDelegate>
```
* 注册
```
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    
    [[UIApplication sharedApplication] setStatusBarHidden:YES withAnimation:UIStatusBarAnimationNone];
    [[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];
    
    if (SYSTEM_VERSION_GRATERTHAN_OR_EQUALTO(@"10")) {
        UNUserNotificationCenter *center = [UNUserNotificationCenter currentNotificationCenter];
        center.delegate = self;
        [center requestAuthorizationWithOptions:(UNAuthorizationOptionSound | UNAuthorizationOptionAlert |UNAuthorizationOptionBadge) completionHandler:^(BOOL granted, NSError * _Nullable error) {
            if (!error) {
                [[UIApplication sharedApplication] registerForRemoteNotifications];
            }
        }];
    }else{
         [self registerPush:application];
    }
    [[ZCLibClient getZCLibClient].libInitInfo setAppKey:@"your appKey"];
    // 设置推送是否是测试环境，测试环境将使用开发证书
    [[ZCLibClient getZCLibClient] setIsDebugMode:YES];
    // 错误日志收集
    [ZCLibClient setZCLibUncaughtExceptionHandler];
    return YES;
}
 
-(void)registerPush:(UIApplication *)application{
    // ios8后，需要添加这个注册，才能得到授权
    if ([[UIApplication sharedApplication] respondsToSelector:@selector(registerUserNotificationSettings:)]) {
        //IOS8
        //创建UIUserNotificationSettings，并设置消息的显示类类型
        UIUserNotificationSettings *notiSettings = [UIUserNotificationSettings settingsForTypes:(UIUserNotificationTypeBadge | UIUserNotificationTypeAlert | UIRemoteNotificationTypeSound) categories:nil];
        
        [application registerUserNotificationSettings:notiSettings];
        
    } else{ // ios7
        [application registerForRemoteNotificationTypes:(UIRemoteNotificationTypeBadge|UIRemoteNotificationTypeSound|UIRemoteNotificationTypeAlert)];
    }
}
- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)pToken{
    NSLog(@"---Token--%@", pToken);
    // 注册token
    [[ZCLibClient getZCLibClient] setToken:pToken];
}
```
* APNS消息推送及提醒
```
// 是否自动提醒
[[ZCLibClient getZCLibClient] setAutoNotification:YES];
 
// 设置推送环境 
[[ZCLibClient getZCLibClient] setIsDebugMode:NO];
  
```
### 4 ios10权限设置
```
<key>NSCameraUsageDescription</key>
  <string>访问相机</string>
<key>NSLocalizedDescription</key>
  <string>使用推送服务</string>
<key>NSMicrophoneUsageDescription</key>
  <string>访问麦克风</string>
<key>NSPhotoLibraryUsageDescription</key>
  <string>访问相册</string>
```
### **5 发送位置**
发送位置信息，此方法，只能是收到初始化的链接监听到url=sobot://sendlocation时发起定位调用，否则可能发送失败，详细说明见ZCKitInfo.h中的canSendLocation属性说明

```
// 发送位置信息
[ZCSobot sendLocation:@{
                        @"lat":@"40.001693",
                        @"lng":@"116.353276",
                        @"localLabel":@"北京市海淀区学清路38号金码大厦A座23层金码大酒店",
                        @"localName":@"云景四季餐厅",
                        @"file":fullPath}];
```
## 三、自定义设置（可选）
### 用户会话页面支持UI自定义
* 在导航栏区域，我们支持自定义导航栏区域的颜色及其字体颜色；
* 在会话页面区域，我们支持自定义会话区域的背景颜色、会话气泡颜色、会话字体颜色、提示气泡颜色、提示字体颜色、时间文字颜色；
* 在底部区域，我们支持自定义底部bottom背景颜色及输入框线条背景颜色；
* 其它部分，我们支持自定义相册导航栏的背景颜色及文字颜色、评价弹框中的文字颜色及按钮颜色、录音控件中的文字、商品详情展示中文字颜色（标题、详情、标签、发送）；

注：代码未涉及到的自定义UI，可以通过替换SobotKit.bundle中的图片，达到你想要的效果

注意：

  目前SDK仅支持超链接A、斜体I，加粗：strong、b，  换行br这几种html标签，可随意组合，对于除上述之外的html标签无法很好处理，可能出现无法预料的效果；

1 ZCKitInfo类说明（UI相关配置）

&amp;nbsp;

| 属性名称   | Y/N   | 数据类型   | 说明   | 备注   |    |
|:----|:----|:----|:----|:----|:----|
| isOpenEvaluation   | 可选   | BOOL   | 点击返回时是否开启满意度评价   | 默认为NO 未开启   |    |
| isCloseAfterEvaluation   | 可选   | BOOL   | 点击返回时开启满意度评价后，评价完人工是否关闭会话   | 默认为NO，未开启   |    |
| isShowTansfer   | 可选   | BOOL   | 机器人优先模式，是否直接显示转人工按钮（值为NO时，会在人工无法回答时显示转人工按钮）   | 默认为YES显示转人工按钮   |    |
| unWordsCount   | 可选   | NSString   | 机器人优先模式，通过记录机器人未知说辞的次数设置是否直接显示转人工按钮   | 默认不设置   |    |
| isOpenRecord   | 可选   | BOOL   | 是否开启语音功能   | 默认YES，开启   |    |
| isShowNickName   | 可选   | BOOL   | 留言页面是否显示昵称输入框   | 默认NO不显示   |    |
| isAddNickName   | 可选   | BOOL   | 非必须输入，留言时是否必须输入昵称   | 默认为NO   |    |
| titleFont   | 可选   | UIFont   | 顶部标题的font   |    |    |
| listTitleFont   | 可选   | UIFont   | 页面返回按钮，输入框，评价提交按钮。Toast 提示语font   |    |    |
| listDetailFont   | 可选   | UIFont   | 网络提醒font   |    |    |
| customlistDetailFont   | 可选   | UIFont   | 评价页面中“是否有以下情况” font   |    |    |
| listTimeFont   | 可选   | UIFont   | 消息提醒（转人工。客服接待等） font   |    |    |
| chatFont   | 可选   | UIFont   | 聊天气泡中文字 font   |    |    |
| voiceButtonFont   | 可选   | UIFont   | 录音按钮的文字 font   |    |    |
| goodsTitle   | 可选   | UIFont   | 商品详情cell 中title的文字 font   |    |    |
| goodsDetFont   | 可选   | UIFont   | 商品详情cell中摘要的文字 font   |    |    |
| goodSendBtnColor   | 可选   | UIColor   | 商品详情cell中btn的背景色   |    |    |
| backgroundColor   | 可选   | UIColor   | 对话页面背景色   |    |    |
| customBannerColor   | 可选   | UIColor   | 自定义风格颜色：导航   |    |    |
| imagePickerColor   | 可选   | UIColor   | 相册导航栏的颜色   |    |    |
| imagePickerTitleColor   | 可选   | UIColor   | 相册导航栏的标题颜色   |    |    |
| leftChatColor   | 可选   | UIColor   | 左边聊天气泡的颜色   |    |    |
| rightChatColor   | 可选   | UIColor   | 右边聊天气泡的颜色   |    |    |
| leftChatSelectedColor   | 可选   | UIColor   | 左边气泡复制选中的颜色   |    |    |
| rightChatSelectedColor   | 可选   | UIColor   | 右边气泡复制选中的颜色   |    |    |
| backgroudBottomColor   | 可选   | UIColor   | 底部bottom的背景颜色   |    |    |
| commentoTherButtonBgColor   | 可选   | UIColor   | 评价普通按钮选中背景颜色和边框颜色   |    |    |
| commentCommitButtonColor   | 可选   | UIColor   | 评价（立即结束、取消）按钮文字颜色   |    |    |
| BgTipAirBubblesColor   | 可选   | UIColor   | 提示气泡的背景颜色   |    |    |
| videoCellBgSelColor   | 可选   | UIColor   | 语音cell选中的背景色   |    |    |
| LineRichColor   | 可选   | UIColor   | 富文本中线条颜色   |    |    |
| submitEvaluationColor   | 可选   | UIColor   | 提交评价按钮的文字颜色   |    |    |
| topViewTextColor   | 可选   | UIColor   | 顶部文字颜色   |    |    |
| leftChatTextColor   | 可选   | UIColor   | 左边气泡文字颜色   |    |    |
| rightChatTextColor   | 可选   | UIColor   | 右边气泡文字颜色   |    |    |
| timeTextColor   | 可选   | UIColor   | 时间文字的颜色   |    |    |
| tipLayerTextColor   | 可选   | UIColor   | 提示气泡的颜色   |    |    |
| serviceNameTextColor   | 可选   | UIColor   | 客服昵称颜色   |    |    |
| nickNameTextColor   | 可选   | UIColor   | 提示cell中客服昵称的文字颜色   |    |    |
| chatLeftLinkColor   | 可选   | UIColor   | 左边气泡中的链接颜色   |    |    |
| chatRightLinkColor   | 可选   | UIColor   | 右边气泡中链接颜色   |    |    |
| goodsTitleTextColor   | 可选   | UIColor   | 商品cell中title的文字颜色   |    |    |
| goodsTipTextColor   | 可选   | UIColor   | 商品cell中标签的文字颜色   |    |    |
| goodsDetTextColor   | 可选   | UIColor   | 商品cell中摘要的文字颜色   |    |    |
| goodsSendTextColor   | 可选   | UIColor   | 商品详情cell中发送的文字颜色   |    |    |
| isSetPhotoLibraryBgImage   | 可选   | BOOL   | 是否设置相册背景图片   |    |    |
| goodSendBtnColor   | 可选   | UIColor   | 商品发送按钮的背景色   |    |    |
| socketStatusButtonBgColor   | 可选   | UIColor   | 导航栏中“连接中”的背景色   |    |    |
| socketStatusButtonTitleColor   | 可选   | UIColor   | 导航栏中“连接中”的文字颜色   |    |    |
| satisfactionSelectedBgColor   | 可选   | UIColor   | 评价页“已解决”和“未解决”背景色   |    |    |
| satisfactionTextSelectedColor   | 可选   | UIColor   | 评价页“已解决”和“未解决”文字颜色   |    |    |
| isOpenRobotVoice   | 可选   | BOOL   | 是否开启机器人语音（需要开通，未开通，机器人语音无法识别）   | 默认NO，未开启   |    |
| navcBarHidden   | 可选   | BOOL   | SDK 页面中使用自定义的导航栏，不在使用系统的导航栏（影藏）   | 默认 为NO   |    |
| moreBtnNolImg   | 可选   | NSString   | 自定义导航栏更多按钮默认状态图片   |    |    |
| moreBtnSelImg   | 可选   | NSString   | 自定义导航栏更多按钮选中状态图片   |    |    |
| turnBtnSelImg   | 可选   | NSString   | 转人工按钮选中状态图片   |    |    |
| turnBtnNolImg   | 可选   | NSString   | 转人工按钮默认状态图片   |    |    |
| topBackSelImg   | 可选   | NSString   | 返回按钮选中状态图片   |    |    |
| topBackNolImg   | 可选   | NSString   | 返回按钮默认状态图片   |    |    |
| topBackNolColor   | 可选   | UIColor   | 导航栏返回按钮默认状态背景色   |    |    |
| topBackSelColor   | 可选   | UIColor   | 导航栏返回按钮高亮状态背景色   |    |    |
| topViewBgColor   | 可选   | UIColor   | 自定义导航栏背景色   |    |    |
| cusMoreArray   | 可选   | NSMutableArray   | 自定义输入框下方更多(+号图标)按钮下面内容(不会替换原有内容，会在原有基础上追加) 填充内容为：ZCLibCusMenu.h title:按钮名称 url：点击链接(点击后会调用初始化linkBock) imgName:本地图片名称，如xxx@2x.png,icon=xxx   |    |    |
| cusMenuArray   | 可选   | NSMutableArray   | 自定义快捷入口 填充内容为： ZCLibCusMenu.h  url: 快捷入口链接(点击后会调用初始化linkBock)  title: 按钮标题  lableId: 自定义快捷入口的ID   |    |    |
| topBackTitle   | 可选   | NSString   | 聊天页面 左上角 返回按钮的文字 （默认 “返回”）   |    |    |
| canSendLocation   | 可选   | BOOL   | 人工状态，是否可以发送位置 【 注意： 由于每个App定位插件选择不同，智齿没有实现选择位置功能，所以需要自行传递位置到SDK以及打开显示，步骤如下： 1、实现messageLinkClick事件（ZCSobot startZCChatVC函数中） 2、当收到link = sobot://sendlocation 调用智齿接口发送位置信息 3、当收到link = sobot://openlocation?latitude=xx&longitude=xxx&address=xxx 可根据自己情况处理相关业务   |    |    |
| isShowTelIcon   | 可选   | BOOL   | 导航栏右上角 是否显示 拨号按钮 默认不显示    注意：和isShowEvaluation 互斥 只能设置一个有效   |    |    |
| customTel   | 可选   | NSString   | 当导航栏右上角 显示 拨号按钮时  （和isShowTelIcon 一起设置有效）   |    |    |
| isSendInfoCard   | 可选   | BOOL   | 商品卡片信息是否自动发送（转人工成功时，自动发送商品卡片信息） 默认不发送   |    |    |
| isShowClose   | 可选   | BOOL   | 导航栏右上角 是否显示 关闭按钮 默认不显示，关闭按钮，点击后无法监听后台消息（2.7.6新增）   |    |    |
| cusRobotMoreArray   | 可选   | NSMutableArray   | 自定义输入框下方更多(+号图标)按钮下面内容(不会替换原有内容，会在原有基础上追加)填充内容为：ZCLibCusMenu.h   |    |    |
| isShowCloseSatisfaction   | 可选   | BOOL   | 针对关闭按钮，单独设置是否显示评价界面，默认不显示   |    |    |
|    |    |    |    |    |    |



2 ZCLibInitInfo类说明



&amp;nbsp;

|    |    |    |
|:----|:----|:----|
|    |    |    |


&amp;nbsp;

| 属性名称   | Y/N   | 数据类型   | 说明   | 备注   |    |
|:----|:----|:----|:----|:----|:----|
| customInfo   | 可选   | NSMutableDictionary   | 自定义属性   | 以KEY-VALUE键值对存储   |    |
| phone   | 可选   | NSString   | 用户手机号码   | 默认为空，用于客服工作台显示。该字段为可选择字段。   |    |
| realname   | 可选   | NSString   | 用户姓名   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| email   | 可选   | NSString   | 用户邮箱   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| nickName   | 可选   | NSString   | 用户昵称   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| weiChat   | 可选   | NSString   | 用户微信号码   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| weiBo   | 可选   | NSString   | 用户微博号码   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| userSex   | 可选   | NSString   | 用户性别   | 默认为空，用于客服工作台显示。该字段为可选择字段。   |    |
| userBirthday   | 可选   | NSString   | 用户的生日   | 默认为空，用于客服工作台显示，该字段为可选字段。传入格式：20170323 如果不是这个格式，初始化接口会给过滤掉   |    |
| userRemark   | 可选   | NSString   | 备注   | 默认为空，用于客服工作台显示，该字段为可选字段。   |    |
| qqNumber   | 可选   | NSString   | 用户的QQ号码   | 用于客服工作台显示，该字段为可选字段。   |    |
| avatarUrl   | 可选   | NSString   | 用户的头像Url   | 不设置，取默认值（SDK图片资源包中的用户默认头像）用于聊天页面中用户头像的，该字段为可选字段。   |    |
| sourceTitle   | 可选   | NSString   | 接入来源页标题   | 标记用户浏览页面标题，该字段为可选字段。   |    |
| sourceURL   | 可选   | NSString   | 接入来源页url   | 该字段为可选字段。   |    |
| appKey   | 必选   | NSString   | App唯一标识   | 必须设置，不设置初始化不成功。   |    |
| receptionistId   | 可选   | NSString   | 指定客服ID   | 设置指定客服ID，客户可以在转人工的操作中直接转到指定的客服，不设置按默认的转人工流程执行。   |    |
| tranReceptionistFlag   | 可选   | int   | 是否必须转入指定客服   | 转指定客服不在线，是否可以再转到其他客服（0 可转入其他客服 1 必须转入指定客服）。   |    |
| userId   | 可选   | NSString   | 用户标识   | 对接用户可靠身份，不建议为null   |    |
| robotId   | 可选   | NSString   | 对接机器人ID   | 可以对接指定机器人   |    |
| skillSetId   | 可选   | NSString   | 对接技能组ID   | 设置技能组ID之后，转人工不在弹技能组弹框，直接转到该技能组中的客服，不设置此字段按默认的转人工流程执行。   |    |
| skillSetName   | 可选   | NSString   | 对接技能组名称   | 和对接的技能组ID要匹配，设置技能组昵称之后，转人工不在弹技能组弹框，直接转到该技能组中的客服，不设置此字段按默认的转人工流程执行。   |    |
| serviceModdel   | 可选   | NSString   | 自定义接入模式   | 0 默认跟随系统设置 1仅机器人 2仅人工 3机器人优先 4人工优先   |    |
| titleType   | 可选   | NSString   | 聊天页顶部标题自定义方式   | （0 默认 1企业名称 2.自定义字段）   |    |
| customTitle   | 可选   | NSString   | 聊天页顶部标题   | 自定义字段（如果传入优先使用该字段）   |    |
| scopeTime   | 可选   | NSString   | 历史记录时间范围   | 单位分钟（可设置有效范围：10分钟~48小时之间）   |    |
| customAdminHelloWord   | 可选   | NSString   | 自定义客服欢迎语   | 默认为空   |    |
| customRobotHelloWord   | 可选   | NSString   | 自定义机器人欢迎语   | 默认为空   |    |
| customUserTipWord   | 可选   | NSString   | 自定义用户超时提示语   | 默认为空   |    |
| customAdminNonelineTitle   | 可选   | NSString   | 自定义客服不在线的说辞   | 默认为空   |    |
| customAdminTipWord   | 可选   | NSString   | 自定义客服超时提示语   | 默认为空   |    |
| customUserOutWord   | 可选   | NSString   | 自定义用户超时下线提示语   | 默认为空   |    |
| customerFields   | 可选   | NSDictionary   | 用户自定义字段   | 默认为空   |    |
| isEnableHotGuide   | 可选   | BOOL   | 是否显示请求热点引导问题接口   | 默认不显示   |    |
| hotguideDict   | 可选   | NSDictionary   | 热点引导问题的扩展字段   | 默认为空   |    |
| goodMsgType   | 可选   | int   | 自定发送商品订单信息类型 0 不发 1 给机器人发送 2 给人工发送 3 机器人和人工都发送   |    |    |
| goodMsg   | 可选   | NSString   | 自动发送商品订单信息内容 例如：“商品订单编号 ：xxxx”   |    |    |
| customGroupType   | 可选   | NSArray   | 转人工指定技能组溢出   | [{"actionType":"to_group","optionId":"3","deciId":"162bb6bb038d4a9ea018241a30694064","spillId":"4"}, {"actionType":"to_group","optionId":"4","deciId":"a457f4dfe92842f8a11d1616c1c58dc1"}]  actionType:执行动作类型：to_group:转接指定技能组 optionId:是否溢出  指定技能组时：3：溢出，4：不溢出。 deciId:指定的技能组。 spillId:溢出条件  指定客服组时：4:技能组无客服在线,5:技能组所有客服忙碌,6:技能组不上班,7:智能判断   |    |
| queueFirst   | 可选   | int   | 指定客户优先   | 指定客户优先 同PC端 设置-在线客服分配-排队优先设置-指定客户优先   开启传1 默认不设置 开启后 指定客户发起咨询时，如果出现排队，系统将优先接入。   |    |
| summaryParams   | 可选   | NSDictionary   | 转人工时传输服务总结自定义字段   | 需要与后台自定义字段-服务总结自定义字段配合使用 initInfo.summaryParams = @{@"your keyId":@"your value"};   |    |
| isVip   | 可选   | NSString   | 指定客户是否为vip，0:普通 1:vip   | ，同PC端 设置-在线客服分配-排队优先设置-VIP客户排队优先   开启传1 默认不设置，开启后 指定客户发起咨询时，如果出现排队，系统将优先接入。   |    |
|      |    |    |    |    |    |



### 3 对接指定技能组
获取技能组编号

![图片](https://images-cdn.shimo.im/nZEF1lJvGmwe35uk/image.png!thumbnail)

```
// 外部直接定义技能组（可选，如果传入技能组ID那么SDK内部转人工之后不在弹技能组的选择框，直接跳转到传入ID所对应的技能组中。）
// 如果选择传入技能组，根据传递的值转接到对应的技能组,不传不起作用
uiInfo.skillSetId =  @"技能组ID";
```
### 4 商品页咨询信息并支持直接发送消息卡片
```
// 商品的自定义类 ZCProductInfo  如果选择添加商品信息，请添加以下信息，其中标题"title"和页面地址url"link"是必填字段，如果没有添加页面中是不会显示的。
ZCProductInfo *productInfo = [ZCProductInfo new];
//thumbUrl 缩略图地址
productInfo.thumbUrl = @"缩略图的Url";
//  title 标题 (必填)
productInfo.title = @"标题";
//  desc 摘要
productInfo.desc = @"摘要";
//  label 标签
productInfo.label = @"标签";
//  页面地址url（必填) 
productInfo.link = @"发送商品链接";
uiInfo.productInfo = productInfo;
//手动调用直接发送商品卡片
ZCProductInfo *productInfo = [ZCProductInfo new];
productInfo.thumbUrl = @"缩略图地址";
productInfo.title = @"标题";
productInfo.desc = @"摘要";
productInfo.label = @"标签";
productInfo.link = @"页面链接";
[ZCSobot sendProductInfo:productInfo];

```


### 5 留言页面用户信息项自定义配置
您可在留言页中设置用户联系方式的各显示字段（显示和添加，可选）。

```
// 留言页面中是否显示昵称
uiInfo.isShowNickName = YES;
// 提交留言时，在选择显示昵称之后，选择昵称是否是必填项，如果是必填，昵称提交时不能为空。
uiInfo.isAddNickName = NO; 
```
### 6 获取未读消息数
```
//直接获取未读消息数
[[ZCLibClient getZCLibClient] getUnReadMessage];
```
### 7 清空未读消息数
```
//清空未读消息数
 [[ZCLibClient getZCLibClient] clearUnReadNumber:@"userId"];
```
### 8 对接机器人
获取机器人编号：

![图片](https://uploader.shimo.im/f/W2pQB7S77Icn4zFl.png!thumbnail)

![图片](https://uploader.shimo.im/f/jeD7WTbdu8Qgotbp.png!thumbnail)

```
// 对接机器人ID （指定对接的机器人，如果不设置，取默认）
uiInfo.robotId =  @"机器人ID";
```
### 9 对接指定客服
获取指定客服ID

![图片](https://uploader.shimo.im/f/QHFx5x2XV1s8P40X.png!thumbnail)

![图片](https://uploader.shimo.im/f/xYqY9eLerv05KpmS.png!thumbnail)

```
// 指定客服ID （指定对接的客服，如果不设置，取默认）
uiInfo.receptionistId =  @"客服ID";
// 设置指定客服之后是否必须转入指定客服 （0 可转入其他客服 1 必须转入指定客服  注意：如果设置为1 ，当指定的客服不在线，不能再转接到其他客服）
uiInfo.tranReceptionistFlag =  @"0";
```
### 10 设置用户自定义字段
开发者可以直接传入这些用户信息，供客服查看。在工作台自行配置所需要显示的字段，配置方法如下图：

![图片](https://uploader.shimo.im/f/V8sOgRqOiQknpVYi!thumbnail)


```
// 设置用户自定义字段
- (void)customUserInformation:(ZCLibInitInfo*)initInfo{
  initInfo.customerFields = @{@"customField22":@"我是自定义的分校",
                              @"userSex":@"保密",
                              @"weixin":@"微信号",
                              @"weibo":@"微博账号",
                              @"birthday":@"2017-06-08"};
}
```

### **11 自定义接入模式**
根据自身业务的需要，可进行以下初始化参数配置，控制接入模式：

```
// 是否开启语音功能 默认开启
    kitInfo.isOpenRecord = @"YES";
// 是否开启机器人语音，（付费，否则语音无法识别）
    kitInfo.isOpenRobotVoice = @"YES";
// 是否显示转人工按钮
   kitInfo.isShowTansfer = @"YES";
// 机器人未知回复次数
kitInfo.unWordsCount = @"1";
// 是否开启智能转人工 (如输入“转人工”，直接转接人工),需要隐藏转人工按钮，请参见isShowTansfer和unWordsCount属性
kitInfo.isOpenActiveUser = @"YES";
// 智能转人工关键字，关键字作为key{@"转人工",@"1",@"R":@"1"}
kitInfo.activeKeywords =  @{@"转人工":@"",@"R":@"",@"r":@""};
//自定义接待模式 注意接待模式本地设置后本地优先，PC端设置接待模式不在起效，建议使用PC端的设置
1只有机器人,2.仅人工 3.智能客服-机器人优先 4智能客服-人工客服优先'默认 0 ，跟随系统设置  
initInfo.serviceMode = 4;
```
### 12 自定义聊天页标题样式
```
// 导航栏背景颜色
kitInfo.customBannerColor  = [UIColor redColor];
// 相册导航栏背景颜色
kitInfo.imagePickerColor =  [UIColor redColor];
//  聊天页顶部标题 的自定义方式 0.默认  1.企业名称  2.自定义字段
    initInfo.titleType =  @"0";
//  聊天页顶部标题 自定义字段  （如果传入，优先使用该字段）
    initInfo.customTitle = @"自定义标题";
```
**13 返回时要求用户评价，关闭时要求用户评价**

```
//返回或关闭时是否开启满意度评价 默认为NO 未开启
kitInfo.isOpenEvaluation = @"YES";
//评价完人工是否关闭会话（人工满意度评价后释放会话） 默认为NO 未开启
kitInfo.isCloseAfterEvaluation = @"YES";
```
**14 自定义自动应答语**

sdk中的自动应答语可以在pc工作台进行动态设置，如果pc工作台的设置满足不了您的需求，那么您可以使用以下接口在代码中进行本地配置 （注意：本地设置本地优先，PC端不在起效）

```
- (void)customTipWord:(ZCLibInitInfo*)initInfo{
    // 用户超时下线提示语
    initInfo.customUserOutWord = @"用户超时下线提示语";
    // 用户超时提示语
    initInfo.customUserTipWord = @"用户超时提示语";
    // 人工客服提示语
    initInfo.customAdminTipWord = @"人工客服提示语";
    // 机器人欢迎语
    initInfo.customRobotHelloWord = @"机器人欢迎语";
    // 暂无客服在线说辞
    initInfo.customAdminNonelineTitle = @"暂无客服在线说辞";
    // 人工客服欢迎语
    initInfo.customAdminHelloWord  = @"人工客服欢迎语";
}
```

15 自定义聊天记录显示的时间范围

如想设置用户只能看到xx天内的聊天记录，那么可以调用以下方法进行设置

```
  // 历史记录时间范围，单位分钟(例:100-表示从现在起前100分钟的会话)
    initInfo.scopeTime = 100；
```
**16 设置跳转自己的留言页面**

sdk中留言可跳转到自定义页面，如有此需求，可以使用如下方法进行设置：

```
  在启动VC 服从<ZCChatControllerDelegate>协议 
  在启动方法中 target（代理）传入启动VC 
[ZCSobot startZCChatVC:uiInfo with:self target:vc pageBlock:^(ZCChatController *object, ZCPageBlockType type) {
 } messageLinkClick:^(NSString *link) {
}];
实现代理方法：
-(void)openLeaveMsgClick:(NSString*)tipMsg{
// 点击留言的代理事件
    NSLog(@"tipMsg ==%@",tipMsg);
}
```
**17 设置转人工溢出**

sdk中可以设置转人工指定技能组溢出，如有此需求，可以使用如下方法进行设置：

```
/**
 *  转人工 指定技能组 溢出
 * [{"actionType":"to_group","optionId":"3","deciId":"162bb6bb038d4a9ea018241a30694064","spillId":"7"},
 {"actionType":"to_group","optionId":"4","deciId":"a457f4dfe92842f8a11d1616c1c58dc1"}]
 actionType:执行动作类型：to_group:转接指定技能组
 optionId:是否溢出  指定技能组时：3：溢出，4：不溢出。
 deciId:指定的技能组。
 spillId:溢出条件  指定客服组时：4:技能组无客服在线,5:技能组所有客服忙碌,6:技能组不上班,7:智能判断
 */
 
 ZCLibInitInfo *initInfo = [ZCLibClient getZCLibClient].libInitInfo;
    initInfo.customGroupType = @[@{@"actionType":@"to_group",@"optionId":@"3",@"deciId":@"a890849f552b4b69b4a027db4e9a1880",@"spillId":@"4"},
  @{@"actionType":@"to_group",@"optionId":@"3",@"deciId":@"5600aa6786f34629a7484819b8132c3a",@"spillId":@"4"}]; 
    
```
**18  自定义发送订单信息**

sdk中可以发送自定义订单信息，如有此需求，可以使用如下方法进行设置：

```
发送订单信息
1.配置按钮
ZCKitInfo *uiInfo=[ZCKitInfo new];
NSMutableArray *arr = [[NSMutableArray alloc] init];
        ZCLibCusMenu *menu1 = [[ZCLibCusMenu alloc] init];
        menu1.title = [NSString stringWithFormat:@"订单"];
        menu1.url = [NSString stringWithFormat:@"sobot://sendOrderMsg"];;
        menu1.imgName = @"zcicon_sendpictures";
        [arr addObject:menu1];
        
    uiInfo.cusMoreArray = arr;
    
2.实现发送事件
[ZCSobot startZCChatVC:uiInfo with:self target:nil pageBlock:^(id object, ZCPageBlockType type) {
        
    } messageLinkClick:^BOOL(NSString *link) {
        if( [link hasPrefix:@"sobot://sendOrderMsg"]){
            // 发送位置信息
             [ZCSobot sendeOrderMsg:@"订单号：123456789012\n商品1：瓜子200g*1\n商品链接：www.sobot.com商品描述：恰恰瓜子恰恰瓜子恰恰瓜子\n恰恰瓜子恰恰瓜子恰恰瓜子恰恰瓜子...\n商品2：矿泉水500ml*12\n商品链接：www.sobot.com商品描述:..."];          
               return YES;
        }
       return NO;
    }];
```

**19 帮助中心**

帮助中心启动代码如下：

```
/**
 *
 *  启动 客户帮助中心
 *
 *  @param info         初始化参数，详情见ZCLibInitInfo not null
 *  @param byController 当前执行跳转的VC           not null
 *  @param delegate     ZCUIChatDelagete        聊天页面的代理，如果实现这个代理用户可以实现留言跳转到自定义页面
 *  @param pageClick    点击返回，UI修改, object为ZCChatController（使用系统导航栏场景） 或者 ZCChatView（使用SDK自定义导航栏场景） 
 *  @param linkBlock    点击消息链接回调，可以为null(注意：如果传递实现后内部将直接返回url，不在做跳转处理)
 *
 */
+(void)openZCServiceCentreVC:(ZCKitInfo *) info
                with:(UIViewController *) byController
                 onItemClick:(void (^)(ZCUIBaseController *object,ZCOpenType type))itemClickBlock;
```
**20  查看对应商户客服是否正在和用户聊天（仅电商版使用）**

```
/**
 *
 *   获取对应商户客服是否正在和用户聊天（仅电商版使用）
 *   appkey：商户id   uid： ZCPlatformInfo 类中的uid 
 **/
+(BOOL)getPlatformIsArtificialWithAppkey:(NSString *)appkey Uid:(NSString*)uid;
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
 ZCPlatformInfo *info = [_listArray objectAtIndex:indexPath.row];
[ZCSobot getPlatformIsArtificialWithAppkey:info.appkey Uid:info.uid];
}
```
**21  自定义转人工事件**
```
自定义转人工事件 
如果实现该方法，SDK中转人工事件将交由外部控制处理，您可以跳转到自己设计的技能组页面，或者切换商品信息等，最后调取 -(void)turnServiceWithGroupId:(NSString *)groupId  Obj:(id)obj Msg:(NSString*)msg KitInfo:(ZCKitInfo*)uiInfo ZCTurnType:(NSInteger)turnType Keyword:(NSString*)keyword KeywordId:(NSString*)keywordId;方法去执行转人工操作。
/**
 * 自定义转人工回调事件
 * 拦截SDK 转人工事件 用于跳转到自己的app页面动态处理转人工 配置技能组id 商品信息等参数
 ***/
@property (nonatomic,strong)  TurnServiceBlock    turnServiceBlock;
/**
 *  自定义 转人工事件（在turnServiceBlock回调事件中调用）
 *   groupId 传入技能组id
 *   obj   转人工参数
     msg   转人工信息
    uiInfo   配置商品信息和自动发送参数
    turnType  转人工事件类型（按钮触发，关键字触发等）
    Keyword 关键字
    keywordId 关键字id
 **/
-(void)turnServiceWithGroupId:(NSString *)groupId  Obj:(id)obj Msg:(NSString*)msg KitInfo:(id)uiInfo ZCTurnType:(NSInteger)turnType Keyword:(NSString*)keyword KeywordId:(NSString*)keywordId;

示例代码：
  [ZCLibClient getZCLibClient].turnServiceBlock = ^(id obj,NSString *msg,NSInteger turnType, NSString *keyword ,NSString *keywordId) {
            // 自定义商品信息
            //ZCProductInfo *productInfo = [ZCProductInfo new];
            //productInfo.thumbUrl = @"商品图片URL";
            //productInfo.title = @"商品标题";
            //productInfo.desc = @"摘要";
            //productInfo.label = @"标签";
            //productInfo.link = @"http://www.sobot.com";
            //uiInfo.productInfo = productInfo;
            //uiInfo.isSendInfoCard = YES;// 转人工工成功后是否自动发送该商品卡片信息
        [[ZCLibClient getZCLibClient] turnServiceWithGroupId:@"技能组id" Obj:obj Msg:msg KitInfo:uiInfo ZCTurnType:turnType Keyword:keyword KeywordId:keywordId];
    };
```
附：
      智齿 iOS_SDK UI源码 Git下载地址：

       [https://github.com/ZCSDK/sobotKit_UI_iOS](https://github.com/ZCSDK/sobotKit_UI_iOS)

       常见问题解答：

       [https://github.com/ZCSDK/FAQ_iOS](https://github.com/ZCSDK/FAQ_iOS)

### ###  [联系我们](https://www.sobot.com/chat/pc/index.html?sysNum=a76f3cef7d1043c69dd592c3e43f8242&groupId=52a5783defa643fe8f1b994a0e9078cc&moduleType=1)

北京智齿博创科技有限公司

版权所有  侵权必究





